;RacerX.asm
;(c) Bryan Thomas,1997
;Copyright (C) 1997 Bryan Thomas

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#include asm86.h
#include ti86asm.inc

DotX            = $C0F9         ;X position 
DotY            = $C0FA         ;y posit1ion 
Lastd           = $C0FB         ;direction car was going
Newd            = $C0FC         ;direction car is now going
Speed           = $C0FD         ;how fast the car is going
Count           = $C0FE         ;counter
Count2          = $C0FF         ;counter
cont            = $C100         ;copy of the users contrast before the game
check           = $C101
time            = $C102
lap             = $C103
String          = $C104         ; 6 byte
temp            = $C10A         ;temporary var for sprite routine

.org $D748

;Ashell title
        nop
        jp Start
        .dw $0000
        .dw T3title


Start:
        call BUSY_OFF           ;turn the busy off
        call Delay              ;delay so key press isn't read
        call Delay              ;and the intro is not skipped
        call Delay              ;
        call Delay              ;
DrawTitle:                      ;super duper grayscale routine(isn't it shitty)
        ld hl, Title            ;load the first picture
        ld de, $FC00            ;point to video mem 
        ld bc, $0400            ;load the screen offset
        ldir
        ld hl, Title2           ;second picture
        ld de, $FC00
        ld bc, $0400
        ldir
        call GET_KEY
        or a
        jp z,DrawTitle 
        nop                     ;delay so the contrast screen isn't skipped
        nop
        
optionscreen:
        ld a,0
        call _clrLCD            ;load coordinates into $C00F
        ld hl,0
        ld ($C00F),hl
        set 3,(iy+5)
        ld hl,TTitle
        call _puts
        res 3,(iy+5)
        ld de,$0404
        ld ($C00F),de
        ld hl,contrast
        call _puts            
        ld de,$0405
        ld ($C00F),de
        ld hl,play
        call _puts            
        ld hl,$3A02
        ld ($C37C),hl
        ld hl,Coder
        call _vputs
        ld a,($C008)
        ld (cont),a
        ld a,20
        ld (DotX),a
        ld (DotY),a
        call DrawcarR
keypoop:        
        call DrawcarIntr
        call GET_KEY
        cp K_ENTER
        jp z,Init
        cp K_PLUS
        call z,rcontrast
        cp K_MINUS
        call z,dcontrast
        cp K_F1
        jp z,ENDITOKAY
        jr keypoop

rcontrast:
        ld a,($C008)
        cp 31
        ret z
        inc a
        ld ($C008),a
        out (2),a
        ret

dcontrast:
        ld a,($C008)
        cp 0 
        ret z
        dec a
        ld ($C008),a
        out (2),a
        ret
        
Init:
        ld a,0          ;set speed to zero
        ld (Speed),a
        ld (Count),a
        ld (check),a
        ld (Count2),a    ;set count to zero
        
        ld a,1
        ld (lap),a
        ld (Lastd),a    ;set last dir to right
        ld (Newd),a     ;set new dir to right
        
        ld a,56
        ld (DotX),a     ;set DotX to 5.

        ld a,10
        ld (DotY),a     ;set DotY to 5.
        
                       ;set to graphics mode.

        call _clrLCD
        call DrawTrack 
        call DrawcarR 


KeyTest:        
        ld a,$3e        ;mask out unused keys
        out (1),a       ;send 0 to the keyboard port
        nop             ;give processor time to read keys
        nop             ;
        in a,(1)        ;check the keyboard port directly.
        cp 0            ;no keys pressed?
        jr z,KeyTest  ;no keys pressed, so try again.
        bit 6,a         ;EXIT (among others) pressed?
        jp z,optionscreen;yep. (exit to ti-os)
        bit 5,a         ;2nd (among others) pressed?
        push af
        call z,SpeedUp 
        call nz,SlowDn 
        pop af
        bit 2,a         ;RIGHT (among others) pressed?
        push af
        call z,TurnAnti 
        pop af
        bit 1,a         ;Left  (among others)pressed?
        push af
        call z,TurnClock 
        pop af
        call  Delay
        call  Delay
        call  Delay 
        call  Delay
        call  Delay
        call  Delay
        call  Check
        jp  KeyTest  ;done checking, loop back to the top
       

Check:   ;procedure to check if the car is at a check point
        ld a,(DotX)
        cp 106
        ret nz
        ld a,(DotY)
        cp 9
        jp p,lower
        ret
lower:
        ld a,(DotY)
        cp 20
        jp m,Yescheck
        ret
Yescheck:
        ld hl,lap
        inc (hl)
        ret
         

DrawTrack:      ; Updates score, level and lives
        ld hl, Track
        ld de, $FC00
        ld bc, $0400
        ldir
        ld hl,$0036
        ld ($C37C),hl
        ld hl,lap
        ld l,(hl)
        ld h,0
        ld b,1
        jp DM_HL_Deci
        ;ld hl,$006D
        ;ld ($C37C),hl
        ;ld hl,time
        ;ld l,(hl)
        ;ld h,0         
        ;ld b,3         
        ;jp  DM_HL_Deci

DM_HL_Deci:            ; Display HL in menu style with leading zeros
 ld de,String+5
 xor a
 ld (de),a
RepUnp:
 dec de
 call UNPACK_HL
 add a,48
 ld (de),a
 djnz RepUnp
 ex de,hl
 jp _vputs
        
        ret


SpeedUp:
        ld a,(Speed)                ;ld speed to a
        cp 8                        ;is it already 8 then move
        jp z,MoveSp               ;if not 8 then increase it
        inc a
        cp 8
        call z,MoveSp
        inc a
        ld (Speed),a
        call MoveSp 
        ret
SlowDn:
        ld a,(Speed)
        cp 0 
        ret z
        dec a
        ld (Speed),a
        call MoveSp 
        ret

TurnClock:
       ; ld a,(Speed)
       ; cp 0 
       ; ret z
        call Delay 
        ld a,(Lastd)
        inc a
        ld (Newd),a
        cp 17
        call z,Reset 
        ld (Lastd),a
        ;call DrawTrack 
        call DrawNew 
        ret
Reset:
        ld a,1
        ld (Newd),a
        ret

TurnAnti:
        ;ld a,(Speed)
        ;cp 0 
        ;ret z
        call Delay 
        ld a,(Lastd)
        dec a
        ld (Newd),a
        cp 0
        call z,Reset2 
        ld (Lastd),a
        ;call DrawTrack
        call DrawNew 
        ret
Reset2:
        ld a,16
        ld (Newd),a
        ret

MoveSp:
        ld a,(Speed)
        cp 1
        call z,Delay 
        call z,Delay 
        call z,Delay 
        call z,Delay 
        call z,Delay 
        call z,Delay4 
        call z,Move 
        ld a,(Speed)
        cp 2
        call z,Delay 
        call z,Delay 
        call z,Delay 
        call z,Delay 
        call z,Delay4 
        call z,Move 
        ld a,(Speed)
        cp 3
        call z,Delay 
        call z,Delay 
        call z,Delay 
        call z,Delay4 
        call z,Move 
        ld a,(Speed)
        cp 4
        call z,Delay 
        call z,Delay 
        call z,Delay3  
        call z,Delay4 
        call z,Move 
        ld a,(Speed)
        cp 5
        call z,Delay 
        call z,Delay2 
        call z,Move 
        ld a,(Speed)
        cp 6
        call z,Delay2 
        call z,Delay3 
        call z,Move 
        ld a,(Speed)
        cp 7
        call z,Delay3 
        call z,Delay4 
        call z,Move 
        ld a,(Speed)
        cp 8
        call z,Delay3  
        call z,Delay4 
        call z,Delay
        call z,Delay 
        call z,Delay
        call z,Delay
        call z,Delay
        call z,Delay
        call z,Move 
        ld a,(Speed)
        ret


Move:   
        ld a,(Newd)
        cp 1
        call z,moveright 
        ld a,(Newd)
        cp 2
        call z,movedi2 
        ld a,(Newd)
        cp 3
        call z,movedi3 
        ld a,(Newd)
        cp 4
        call z,movedi4 
        ld a,(Newd)
        cp 5
        call z,movedown 
        ld a,(Newd)
        cp 6
        call z,movedi6 
        ld a,(Newd)
        cp 7
        call z,movedi7 
        ld a,(Newd)
        cp 8 
        call z,movedi8 
        ld a,(Newd)
        cp 9
        call z,moveleft 
        ld a,(Newd)
        cp 10
        call z,movedi10 
        ld a,(Newd)
        cp 11
        call z,movedi11 
        ld a,(Newd)
        cp 12
        call z,movedi12 
        ld a,(Newd)
        cp 13
        call z,moveup 
        ld a,(Newd)
        cp 14
        call z,movedi14 
        ld a,(Newd)
        cp 15
        call z,movedi15 
        ld a,(Newd)
        cp 16
        call z,movedi16 
        ret


GetPixel:
        call FindPixel
        ld de,$FC00
        add hl,de
        and (hl)
        ret


CheckCrash:
        ld a,(DotY)
        ld c,a
        ld a,60
        sub c
        ld c,a
        ld a,(DotX)
        inc a
        inc a
        inc a
        ld b,a
        call GetPixel
        or 0
        jp nz,Crash            ;if so, DIE!
        ld a,(DotY)
        ld c,a
        ld a,(DotX)
        ld b,a
        ret



moveup:
        ld a,(DotY)     ;load Y position into register A
        inc a           ;a = a+1
        ld (DotY),a     ;reload NEW y position into memory slot DotY.
        ld a,(Newd)
        ld (Lastd),a
        call  DrawNew 
        ret             ;done.

movedown:
        ld a,(DotY)     ;load Y position into A
        dec a           ;a=a-1
        ld (DotY),a     ;refresh the memory with new position
        ld a,(Newd)
        ld (Lastd),a
        call  DrawNew 
        ret             ;done.

moveleft:
        ld a,(DotX)     ;load X position into A
        dec a           ;a = a-1
        ld (DotX),a     ;set X position to new number.
        ld a,(Newd)
        ld (Lastd),a
        call  DrawNew 
        ret
movedi3:
        ld a,(Count)
        inc a
        cp 3
        call z,reset3 
        ld (Count),a
        ld a,(Count)
        cp 1
        call z,moveright             
        ld a,(Count)
        cp 2
        call z,movedown 
        ld a,(Newd)
        ld (Lastd),a
        ret
reset3: ld a,1                   
        ld (Count),a
        ret

reset4: ld a,1                   
        ld (Count2),a
        ret

movedi15:
        ld a,(Count)
        inc a
        cp 3
        call z,reset4 
        ld (Count),a
        ld a,(Count)
        cp 1
        call z,moveright             
        ld a,(Count)
        cp 2
        call z,moveup 
        ld a,(Newd)
        ld (Lastd),a
        
        ret

movedi7:
        ld a,(Count)
        inc a
        cp 3
        call z,reset4 
        ld (Count),a
        ld a,(Count)
        cp 1
        call z,moveleft             
        ld a,(Count)
        cp 2
        call z,movedown 
        ld a,(Newd)
        ld (Lastd),a
        ret
movedi11:
        ld a,(Count)
        inc a
        cp 3
        call z,reset4 
        ld (Count),a
        ld a,(Count)
        cp 1
        call z,moveleft             
        ld a,(Count)
        cp 2
        call z,moveup 
        ld a,(Newd)
        ld (Lastd),a
        ret

movedi2:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4 
        ld (Count2),a
        ld a,(Count2)
        cp 1
        call z,moveright             
        ld a,(Count2)
        cp 2
        call z,moveright
        ld a,(Count2)
        cp 3
        call z,movedown
        ld a,(Newd)
        ld (Lastd),a
        ret

movedi10:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4
        ld (Count2),a
        ld a,(Count2)
        cp 1
        call z,moveleft
        ld a,(Count2)
        cp 2
        call z,moveleft
        ld a,(Count2)
        cp 3
        call z,moveup
        ld a,(Newd)
        ld (Lastd),a
        ret

movedi8:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4
        ld (Count2),a
        ld a,(Count2)    
        cp 1
        call z,moveleft            
        ld a,(Count2)
        cp 2
        call z,moveleft
        ld a,(Count2)
        cp 3
        call z,movedown
        ld a,(Newd)
        ld (Lastd),a
        ret

movedi16:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4
        ld (Count2),a
        ld a,(Count2)
        cp 1
        call z,moveright
        ld a,(Count2)
        cp 2
        call z,moveright
        ld a,(Count2)
        cp 3
        call z,moveup
        ld a,(Newd)
        ld (Lastd),a
        ret
movedi6:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4
        ld (Count2),a
        ld a,(Count2)
        cp 1
        call z,movedown
        ld a,(Count2)
        cp 2
        call z,movedown
        ld a,(Count2)
        cp 3
        call z,moveleft
        ld a,(Newd)
        ld (Lastd),a
        ret

movedi4:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4
        ld (Count2),a
        ld a,(Count2)
        cp 1
        call z,movedown
        ld a,(Count2)
        cp 2
        call z,movedown
        ld a,(Count2)
        cp 3
        call z,moveright
        ld a,(Newd)
        ld (Lastd),a
        ret

movedi12:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4
        ld (Count2),a
        ld a,(Count2)
        cp 1
        call z,moveup
        ld a,(Count2)
        cp 2
        call z,moveup
        ld a,(Count2)
        cp 3
        call z,moveleft
        ld a,(Newd)
        ld (Lastd),a
        ret

movedi14:
        ld a,(Count2)
        inc a
        cp 4
        call z,reset4
        ld (Count2),a
        ld a,(Count2)
        cp 1
        call z,moveup
        ld a,(Count2)
        cp 2
        call z,moveup
        ld a,(Count2)
        cp 3
        call z,moveright
        ld a,(Newd)
        ld (Lastd),a
        ret

moveright:
        ld a,(DotX)
        inc a
        ld (DotX),a
        call DrawNew
        ld a,(Newd)
        ld (Lastd),a
        ret           

DrawNew:
        call DrawTrack
        call CheckCrash
        ld a,(Lastd)
        cp 1
        call z,DrawcarR 
        ld a,(Lastd)
        cp 2
        call z,Drawcardi2
        ld a,(Lastd)
        cp 3
        call z,Drawcardi3
        ld a,(Lastd)
        cp 4
        call z,Drawcardi4
        ld a,(Lastd)
        cp 5
        call z,DrawcarU
        ld a,(Lastd)
        cp 6
        call z,Drawcardi6
        ld a,(Lastd)
        cp 7
        call z,Drawcardi7
        ld a,(Lastd)
        cp 8
        call z,Drawcardi8
        ld a,(Lastd)
        cp 9
        call z,DrawcarR
        ld a,(Lastd)
        cp 10
        call z,Drawcardi2
        ld a,(Lastd)
        cp 11
        call z,Drawcardi3
        ld a,(Lastd)
        cp 12
        call z,Drawcardi4
        ld a,(Lastd)
        cp 13
        call z,DrawcarU
        ld a,(Lastd)
        cp 14
        call z,Drawcardi6
        ld a,(Lastd)
        cp 15
        call z,Drawcardi7
        ld a,(Lastd)
        cp 16
        call z,Drawcardi8
        ret

Drawcardi2: 
        ld hl,Car2
        call PutSprite 
        ret
        
        

Drawcardi3:
        ld hl,Car3
        call PutSprite
        ret

Drawcardi4: 
        ld hl,Car4
        call PutSprite
        ret
        

Drawcardi6: ;6,14 diagonols
        ld hl,Car6
        call PutSprite
        ret
        

Drawcardi7:  ;7,15
        ld hl,Car7
        call PutSprite
        ret
        
        
Drawcardi8: ;8,16 diagonols
        ld hl,Car8
        call PutSprite
        ret
        
DrawcarIntr:
        ld a,(DotX)
        inc a
        ld (DotX),a
        ld hl,CarR
        call PutSprite
        ret             ;done.

DrawcarR:
        ld hl,CarR
        call PutSprite
        ret             ;done.

DrawcarU:
        ld hl,CarU
        call PutSprite
        ret             ;done.

Crash:
      ld hl,CCra
      call PutSprite
      jp Exit 

CCra:
     .db 8,8
     .db %00001000
     .db %00101000
     .db %00011010
     .db %11111100
     .db %00111111
     .db %01011000
     .db %00010100
     .db %00010000

CarR:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00000000
     .db %00111100
     .db %00111100
     .db %00000000
     .db %00000000
     .db %00000000

CarU:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00011000
     .db %00011000
     .db %00011000
     .db %00011000
     .db %00000000
     .db %00000000

Car8:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00110000
     .db %00111100
     .db %00001100
     .db %00000000
     .db %00000000
     .db %00000000
Car7:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00110000
     .db %00111000
     .db %00011100
     .db %00001100
     .db %00000000
     .db %00000000
Car6:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00110000
     .db %00110000
     .db %00011000
     .db %00011000
     .db %00000000
     .db %00000000
Car4:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00001100
     .db %00001100
     .db %00011000
     .db %00011000
     .db %00000000
     .db %00000000
Car3:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00001100
     .db %00011100
     .db %00111000
     .db %00110000
     .db %00000000
     .db %00000000
Car2:
     .db 8,8
     .db %00000000
     .db %00000000
     .db %00001100
     .db %00111100
     .db %00110000
     .db %00000000
     .db %00000000
     .db %00000000

     

;--------------------------Sprite routine----------------------------------

PutSprite: ; Puts a sprite stored at (HL) at B,C 
  
      ld a,(DotX)
      ld b,a
      ld a,(DotY)
      ld c,a
      ld a,b 
      cp 0
      jp m,PS_Minus 
      jr PS_NotMinus 
PS_Minus: 
      add a,128
      ld b,a
PS_NotMinus: 
      ld (temp),a 
  



      push bc
      push de 
      push hl 
      push hl 
      ld e,b 
      ld d,c 
      call FindPixel 
      ld de,$FC00 
  
      ex de,hl 
      pop hl
      ld b,(hl) 



      inc hl
      ld c,(hl)
      inc hl
      push hl 
      pop ix 
      ex de,hl 
PS_NewRow: 
      push bc
      ld d,(ix)
      inc ix 
      push af 
      push hl 
PS_NewCol: 
      rl d 
      ld e,a 
      jr nc,PS_NoPixel 
      ;************ can be OR or XOR ********************* 
      or (hl) 
      ;*************************************************** 
      ld (hl),a 
      jr PS_NextPixel 
PS_NoPixel: 
      cpl 
      and (hl)
      ld (hl),a
PS_NextPixel: 
      ld a,e
      rrca 
      jr nc,PS_SameByte 
      inc hl 
      push af
      ld a,(temp)
      add a,8
      cp 128
      jp p,PSWrap 
      jr PSEndWrap
PSWrap: 
      push bc 
      ld bc,$FFF0 
      add hl,bc 
      pop bc 
  
PSEndWrap: 
      pop af 



PS_SameByte: 
      djnz PS_NewCol 
      pop hl
      pop af 
      ld de,16

      add hl,de
  
      pop bc 
      dec c 
      jr nz,PS_NewRow 
      pop hl 
      pop de 
      pop bc 
      ret 



 



FindPixel:
        ld a,e 
        and $07 
        ld b,0

        ld c,a
        ld hl,FP_Bits 
        add hl,bc 
        ld b,(hl) 
;56 t-states up to this point 
        ld a,d 
        rlca
        rlca 
        ld l,a 
        ld h,0 
        add hl,hl 
        add hl,hl 
        ld a,e 
        rrca 
        rrca 
        rrca 
        and $0F 
        ld c,a 
        ld a,b 
        ld b,$FC 
        add hl,bc
;150 t-states up to this point 
        ret 



FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01 

Delay:
        ld a,$FF
dloop1:
        dec a
        cp 0
        jr nz,dloop1

        ld a,$FF
dloop2:
        dec a
        cp 0
        jr nz,dloop2

        ret

Delay2:        
        ld a,$FF
d2loop1:
        dec a
        cp 0
        jr nz,d2loop1

        ret


Delay3:
        ld a,$9F
d3loop1:
        dec a
        cp 0
        jr nz,d3loop1
        
        ret
Delay4:
        ld a,$5F
d4loop1:
        dec a
        cp 0
        jr nz,d4loop1
        
        ret

Exit:

       ld hl,$0407
       ld (_curRow),hl
       ld hl,CrashText
       call _puts
       call Delay

        
ENDITOKAY:
        call _clrLCD
        ld a,(cont)
        ld ($C008),a
        out (2),a
        ret 
         
        
 

Title:        
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $FF,$C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7F,$FE
        .db     $FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$18,$0F,$FE
        .db     $FF,$FF,$E0,$00,$00,$00,$00,$00,$00,$1F,$FF,$F8,$00,$64,$01,$FE
        .db     $F8,$00,$18,$00,$00,$00,$00,$00,$00,$10,$00,$06,$01,$84,$00,$9E
        .db     $F8,$00,$06,$00,$00,$00,$00,$00,$00,$10,$00,$01,$86,$02,$00,$86
        .db     $E8,$00,$01,$83,$FF,$00,$00,$07,$FC,$10,$00,$00,$42,$02,$00,$82
        .db     $E8,$00,$00,$42,$01,$07,$FC,$04,$03,$FE,$00,$00,$42,$01,$01,$02
        .db     $C8,$00,$00,$42,$00,$98,$03,$C8,$00,$02,$00,$00,$41,$01,$01,$06
        .db     $C8,$0C,$00,$44,$00,$A0,$00,$28,$00,$02,$0E,$00,$40,$80,$82,$0E
        .db     $88,$0B,$00,$44,$00,$40,$00,$10,$00,$02,$09,$C0,$40,$40,$42,$0A
        .db     $88,$08,$C0,$44,$00,$40,$00,$08,$00,$04,$08,$40,$40,$40,$42,$0A
        .db     $88,$08,$40,$48,$40,$40,$00,$08,$00,$04,$08,$40,$40,$20,$24,$12
        .db     $88,$08,$C0,$48,$40,$27,$C0,$08,$3F,$04,$09,$80,$40,$10,$24,$12
        .db     $88,$0B,$00,$48,$60,$24,$20,$04,$20,$FC,$0E,$00,$40,$10,$14,$22
        .db     $88,$0C,$00,$48,$60,$18,$10,$04,$20,$10,$08,$0F,$FF,$88,$18,$22
        .db     $88,$00,$00,$90,$A0,$18,$08,$7C,$20,$10,$00,$08,$00,$84,$08,$42
        .db     $88,$00,$01,$10,$A0,$10,$0F,$90,$40,$10,$00,$08,$00,$82,$00,$42
        .db     $88,$00,$02,$10,$90,$08,$00,$10,$43,$D0,$00,$0C,$00,$42,$00,$42
        .db     $88,$00,$04,$20,$F0,$08,$00,$10,$7C,$50,$00,$04,$00,$41,$00,$22
        .db     $88,$00,$08,$20,$00,$04,$00,$10,$00,$50,$00,$04,$0F,$C2,$00,$22
        .db     $88,$00,$04,$20,$00,$04,$00,$20,$00,$90,$03,$07,$F0,$02,$00,$12
        .db     $88,$00,$03,$40,$00,$04,$00,$20,$00,$90,$03,$00,$80,$04,$04,$12
        .db     $88,$0C,$00,$C0,$00,$02,$00,$20,$7F,$90,$02,$80,$40,$08,$04,$12
        .db     $88,$0A,$00,$40,$F8,$02,$00,$0E,$40,$10,$02,$80,$20,$08,$0A,$0A
        .db     $88,$09,$00,$20,$88,$01,$00,$72,$40,$10,$02,$40,$20,$10,$0A,$0A
        .db     $88,$08,$80,$19,$04,$01,$00,$42,$40,$10,$02,$40,$10,$20,$11,$06
        .db     $88,$08,$40,$05,$04,$01,$80,$42,$80,$10,$02,$20,$08,$20,$11,$06
        .db     $88,$08,$40,$07,$02,$00,$E1,$82,$80,$10,$02,$20,$18,$40,$21,$02
        .db     $88,$08,$20,$19,$02,$00,$9E,$04,$81,$FC,$02,$10,$60,$80,$20,$82
        .db     $88,$08,$10,$72,$02,$00,$40,$08,$FE,$04,$02,$11,$80,$C0,$40,$8E
        .db     $8F,$FC,$09,$8E,$01,$0F,$C0,$30,$00,$04,$02,$12,$00,$3C,$40,$52
        .db     $80,$0C,$06,$00,$01,$F0,$C1,$C0,$00,$07,$FE,$0C,$00,$03,$80,$62
        .db     $80,$0E,$00,$00,$00,$00,$3E,$40,$00,$08,$00,$02,$00,$06,$00,$02
        .db     $80,$0E,$00,$00,$00,$00,$00,$7F,$FF,$F8,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$80,$00,$00,$00,$07,$FF,$FF,$FC,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$C0,$00,$00,$00,$0F,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$F0,$00,$00,$00,$3F,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$FC,$00,$00,$00,$FF,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$FF,$FF,$F0,$00,$FF,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$07,$FF,$FF,$C0,$00,$3F,$FF,$FF,$FE,$00,$02,$00,$00,$00,$02
        .db     $80,$07,$FF,$FF,$00,$00,$0F,$FF,$FF,$FE,$00,$02,$00,$00,$00,$02
        .db     $80,$03,$FF,$FE,$00,$00,$07,$FF,$FF,$FC,$00,$02,$00,$00,$00,$02
        .db     $80,$00,$FF,$FC,$00,$00,$00,$FF,$FF,$F8,$00,$02,$00,$00,$00,$02
        .db     $80,$00,$3F,$F0,$00,$00,$00,$3F,$FF,$F0,$00,$02,$00,$00,$00,$02
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$00,$00,$06
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$00,$00,$06
        .db     $E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$80,$00,$00,$06
        .db     $E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$80,$00,$00,$0E
        .db     $F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F,$C0,$00,$00,$1E
        .db     $F8,$00,$00,$00,$00,$FC,$00,$00,$00,$00,$00,$3F,$E0,$00,$00,$3E
        .db     $FC,$00,$00,$00,$01,$FE,$00,$00,$00,$00,$00,$7F,$F0,$00,$00,$FE
        .db     $FF,$00,$00,$00,$03,$FF,$00,$00,$00,$00,$01,$FF,$FC,$00,$03,$FE
        .db     $FF,$C0,$00,$00,$0F,$FF,$C0,$00,$00,$00,$07,$FF,$FF,$00,$0F,$FE
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $80,$0C,$A0,$CC,$AE,$90,$3A,$92,$2E,$E0,$29,$0E,$00,$27,$77,$02
        .db     $80,$0A,$A0,$AA,$AA,$D0,$12,$AB,$6A,$80,$2B,$0A,$00,$65,$51,$02
        .db     $80,$0C,$40,$CC,$4E,$F0,$13,$AA,$AE,$E0,$29,$0A,$00,$27,$72,$02
        .db     $80,$0A,$40,$AA,$4A,$B0,$12,$AA,$2A,$20,$29,$0A,$00,$21,$12,$02
        .db     $80,$0C,$40,$CA,$4A,$90,$12,$92,$2A,$E0,$13,$AA,$00,$72,$22,$02
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 
       
Title2:        
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $FF,$C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7F,$FE
        .db     $FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$18,$0F,$FE
        .db     $FF,$FF,$E0,$00,$00,$00,$00,$00,$00,$1F,$FF,$F8,$00,$7C,$01,$FE
        .db     $FF,$FF,$F8,$00,$00,$00,$00,$00,$00,$1F,$FF,$FE,$01,$FC,$00,$FE
        .db     $FF,$FF,$FE,$00,$00,$00,$00,$00,$00,$1F,$FF,$FF,$87,$FE,$00,$FE
        .db     $EF,$FF,$FF,$83,$FF,$00,$00,$07,$FC,$1F,$FF,$FF,$C3,$FE,$00,$FE
        .db     $EF,$FF,$FF,$C3,$FF,$07,$FC,$07,$FF,$FF,$FF,$FF,$C3,$FF,$01,$FE
        .db     $CF,$FF,$FF,$C3,$FF,$9F,$FF,$CF,$FF,$FF,$FF,$FF,$C1,$FF,$01,$FE
        .db     $CF,$FF,$FF,$C7,$FF,$BF,$FF,$EF,$FF,$FF,$FF,$FF,$C0,$FF,$83,$FE
        .db     $8F,$FB,$FF,$C7,$FF,$FF,$FF,$FF,$FF,$FF,$F9,$FF,$C0,$7F,$C3,$FA
        .db     $8F,$F8,$FF,$C7,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$7F,$C0,$7F,$C3,$FA
        .db     $8F,$F8,$7F,$CF,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$7F,$C0,$3F,$E7,$F2
        .db     $8F,$F8,$FF,$CF,$FF,$FF,$FF,$FF,$FF,$FF,$F9,$FF,$C0,$1F,$E7,$F2
        .db     $8F,$FB,$FF,$CF,$FF,$FC,$3F,$FF,$E0,$FF,$FF,$FF,$C0,$1F,$F7,$E2
        .db     $8F,$FF,$FF,$CF,$FF,$F8,$1F,$FF,$E0,$1F,$FF,$FF,$FF,$8F,$FF,$E2
        .db     $8F,$FF,$FF,$9F,$BF,$F8,$0F,$FF,$E0,$1F,$FF,$FF,$FF,$87,$FF,$C2
        .db     $8F,$FF,$FF,$1F,$BF,$F0,$0F,$9F,$C0,$1F,$FF,$FF,$FF,$83,$FF,$C2
        .db     $8F,$FF,$FE,$1F,$9F,$F8,$00,$1F,$C3,$DF,$FF,$FF,$FF,$C3,$FF,$C2
        .db     $8F,$FF,$FC,$3F,$FF,$F8,$00,$1F,$FF,$DF,$FF,$FF,$FF,$C1,$FF,$E2
        .db     $8F,$FF,$F8,$3F,$FF,$FC,$00,$1F,$FF,$DF,$FF,$FF,$FF,$C3,$FF,$E2
        .db     $8F,$FF,$FC,$3F,$FF,$FC,$00,$3F,$FF,$9F,$FF,$FF,$F0,$03,$FF,$F2
        .db     $8F,$FF,$FF,$7F,$FF,$FC,$00,$3F,$FF,$9F,$FF,$FF,$80,$07,$FF,$F2
        .db     $8F,$FF,$FF,$FF,$FF,$FE,$00,$3F,$FF,$9F,$FE,$FF,$C0,$0F,$FF,$F2
        .db     $8F,$FB,$FF,$FF,$FF,$FE,$00,$3F,$C0,$1F,$FE,$FF,$E0,$0F,$FB,$FA
        .db     $8F,$F9,$FF,$FF,$8F,$FF,$00,$7F,$C0,$1F,$FE,$7F,$E0,$1F,$FB,$FA
        .db     $8F,$F8,$FF,$FF,$07,$FF,$00,$7F,$C0,$1F,$FE,$7F,$F0,$3F,$F1,$FE
        .db     $8F,$F8,$7F,$FF,$07,$FF,$80,$7F,$80,$1F,$FE,$3F,$F8,$3F,$F1,$FE
        .db     $8F,$F8,$7F,$FF,$03,$FF,$E1,$FF,$80,$1F,$FE,$3F,$F8,$7F,$E1,$FE
        .db     $8F,$F8,$3F,$FF,$03,$FF,$FF,$FF,$81,$FF,$FE,$1F,$E0,$FF,$E0,$FE
        .db     $8F,$F8,$1F,$FE,$03,$FF,$FF,$FF,$FF,$FF,$FE,$1F,$80,$FF,$C0,$FE
        .db     $8F,$FC,$0F,$8E,$01,$FF,$FF,$FF,$FF,$FF,$FE,$1E,$00,$3F,$C0,$72
        .db     $80,$0C,$06,$00,$01,$F0,$FF,$FF,$FF,$FF,$FE,$0C,$00,$03,$80,$62
        .db     $80,$0E,$00,$00,$00,$00,$3E,$7F,$FF,$F8,$00,$02,$00,$06,$00,$02
        .db     $80,$0E,$00,$00,$00,$00,$00,$7F,$FF,$F8,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$80,$00,$00,$00,$07,$FF,$FF,$FC,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$C0,$00,$00,$00,$0F,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$F0,$00,$00,$00,$3F,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$FC,$00,$00,$00,$FF,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$0F,$FF,$FF,$F0,$00,$FF,$FF,$FF,$FE,$00,$02,$00,$06,$00,$02
        .db     $80,$07,$FF,$FF,$C0,$00,$3F,$FF,$FF,$FE,$00,$02,$00,$00,$00,$02
        .db     $80,$07,$FF,$FF,$00,$00,$0F,$FF,$FF,$FE,$00,$02,$00,$00,$00,$02
        .db     $80,$03,$FF,$FE,$00,$00,$07,$FF,$FF,$FC,$00,$02,$00,$00,$00,$02
        .db     $80,$00,$FF,$FC,$00,$00,$00,$FF,$FF,$F8,$00,$02,$00,$00,$00,$02
        .db     $80,$00,$3F,$F0,$00,$00,$00,$3F,$FF,$F0,$00,$02,$00,$00,$00,$02
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$00,$00,$06
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$00,$00,$06
        .db     $E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$80,$00,$00,$06
        .db     $E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$80,$00,$00,$0E
        .db     $F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F,$C0,$00,$00,$1E
        .db     $F8,$00,$00,$00,$00,$FC,$00,$00,$00,$00,$00,$3F,$E0,$00,$00,$3E
        .db     $FC,$00,$00,$00,$01,$FE,$00,$00,$00,$00,$00,$7F,$F0,$00,$00,$FE
        .db     $FF,$00,$00,$00,$03,$FF,$00,$00,$00,$00,$01,$FF,$FC,$00,$03,$FE
        .db     $FF,$C0,$00,$00,$0F,$FF,$C0,$00,$00,$00,$07,$FF,$FF,$00,$0F,$FE
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $80,$0C,$A0,$CC,$AE,$90,$3A,$92,$2E,$E0,$29,$0E,$00,$27,$77,$02
        .db     $80,$0A,$A0,$AA,$AA,$D0,$12,$AB,$6A,$80,$2B,$0A,$00,$65,$51,$02
        .db     $80,$0C,$40,$CC,$4E,$F0,$13,$AA,$AE,$E0,$29,$0A,$00,$27,$72,$02
        .db     $80,$0A,$40,$AA,$4A,$B0,$12,$AA,$2A,$20,$29,$0A,$00,$21,$12,$02
        .db     $80,$0C,$40,$CA,$4A,$90,$12,$92,$2A,$E0,$13,$AA,$00,$72,$22,$02
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 
      
Track:
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $BB,$A0,$00,$00,$1A,$3B,$B0,$00,$19,$BB,$B6,$EC,$EE,$3B,$8E,$02
        .db     $A2,$B2,$49,$24,$9A,$2A,$B0,$09,$A5,$91,$2A,$8C,$AA,$2A,$8A,$02
        .db     $BB,$A9,$24,$92,$5A,$3B,$B0,$15,$09,$91,$22,$CC,$AA,$2A,$8A,$02
        .db     $8A,$32,$49,$24,$9A,$2A,$30,$15,$A5,$91,$22,$8C,$AA,$AA,$AA,$02
        .db     $BA,$20,$00,$00,$1B,$AA,$30,$09,$19,$93,$A2,$EC,$EE,$BB,$AE,$02
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE          
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
        .db     $FF,$C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7F,$FE
        .db     $FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$FE
        .db     $FC,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$FE
        .db     $F8,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7E
        .db     $F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$3E
        .db     $E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1E
        .db     $E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0E
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$06
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$06
        .db     $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$02
        .db     $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$02
        .db     $80,$00,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$00,$02
        .db     $80,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$00,$02
        .db     $80,$01,$FC,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$FC,$00,$02
        .db     $80,$03,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7E,$00,$02
        .db     $80,$07,$C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$3E,$00,$02
        .db     $80,$07,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1E,$00,$02
        .db     $80,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0E,$00,$02
        .db     $80,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0E,$00,$02
        .db     $80,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0E,$00,$02
        .db     $80,$0C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$06,$00,$02
        .db     $80,$0C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$06,$00,$02
        .db     $80,$0C,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$C0,$00,$06,$00,$02
        .db     $80,$0C,$00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$00,$06,$00,$02
        .db     $80,$0C,$00,$1F,$FF,$F8,$00,$00,$00,$00,$07,$F8,$00,$06,$00,$02
        .db     $80,$0C,$00,$3F,$FF,$E0,$00,$00,$00,$00,$01,$FC,$00,$06,$00,$02
        .db     $80,$0C,$00,$3F,$FF,$80,$00,$00,$00,$00,$00,$7C,$00,$06,$00,$02
        .db     $80,$0C,$00,$3F,$FF,$00,$00,$00,$00,$00,$00,$3E,$00,$06,$00,$02
        .db     $80,$0C,$00,$1F,$F8,$00,$00,$00,$00,$00,$00,$1E,$00,$06,$00,$02
        .db     $80,$0C,$00,$0F,$E0,$00,$00,$00,$00,$00,$00,$0F,$00,$06,$00,$02
        .db     $80,$0C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$00,$06,$00,$02
        .db     $80,$0C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$06,$00,$02
        .db     $80,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$06,$00,$02
        .db     $80,$0E,$00,$00,$00,$00,$FF,$FF,$FF,$F0,$00,$07,$00,$06,$00,$02
        .db     $80,$0F,$00,$00,$00,$03,$FF,$FF,$FF,$F8,$00,$07,$00,$06,$00,$02
        .db     $80,$0F,$80,$00,$00,$0F,$FF,$FF,$FF,$FC,$00,$07,$00,$06,$00,$02
        .db     $80,$0F,$C0,$00,$00,$3F,$FF,$FF,$FF,$FE,$00,$07,$00,$06,$00,$02
        .db     $80,$0F,$F0,$00,$00,$FF,$FF,$FF,$FF,$FE,$00,$07,$00,$06,$00,$02
        .db     $80,$0F,$FC,$00,$03,$FF,$FF,$FF,$FF,$FE,$00,$07,$00,$06,$00,$02
        .db     $80,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$00,$07,$00,$06,$00,$02
        .db     $80,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$00,$07,$00,$06,$00,$02
        .db     $80,$07,$FF,$FF,$E0,$00,$3F,$FF,$FF,$FE,$00,$07,$00,$00,$00,$02
        .db     $80,$07,$FF,$FF,$80,$00,$0F,$FF,$FF,$FE,$00,$07,$00,$00,$00,$02
        .db     $80,$03,$FF,$FE,$00,$00,$07,$FF,$FF,$FC,$00,$07,$00,$00,$00,$02
        .db     $80,$00,$FF,$FC,$00,$00,$00,$FF,$FF,$F8,$00,$07,$00,$00,$00,$02
        .db     $80,$00,$3F,$F0,$00,$00,$00,$3F,$FF,$F0,$00,$07,$00,$00,$00,$02
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$00,$00,$06
        .db     $C0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$00,$00,$06
        .db     $E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$80,$00,$00,$06
        .db     $E0,$00,$00,$00,$0F,$FF,$C0,$00,$00,$00,$00,$0F,$80,$00,$00,$0E
        .db     $F0,$00,$00,$00,$3F,$FF,$F0,$00,$00,$00,$00,$1F,$C0,$00,$00,$1E
        .db     $F8,$00,$00,$00,$FF,$FF,$F8,$00,$00,$00,$00,$3F,$E0,$00,$00,$3E
        .db     $FC,$00,$00,$01,$FF,$FF,$FE,$00,$00,$00,$00,$7F,$F0,$00,$00,$FE
        .db     $FF,$00,$00,$07,$FF,$FF,$FF,$80,$00,$00,$01,$FF,$FC,$00,$01,$FE
        .db     $FF,$C0,$00,$1F,$FF,$FF,$FF,$E0,$00,$00,$07,$FF,$FF,$00,$0F,$FE
        .db     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE

CrashText: .db "<!CRASH!>",0        

TTitle:
 .db "Racerx 86       v1.0B",0

Coder:
 .db "Bryan Thomas < br"
 .db "t80@hotmail.com >",0
 
T3title:
 .db "RacerX v1.0 BETA",0

contrast:
 .db "Contrast [+/-]",0
play: 
 .db "exit     [F 1]",0

.end

